
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Chat_messagesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const chat_messages = await db.chat_messages.create(
            {
                id: data.id || undefined,
        
        sender_type: data.sender_type
        ||
        null
            ,
            
        sender_display_name: data.sender_display_name
        ||
        null
            ,
            
        message_text: data.message_text
        ||
        null
            ,
            
        sent_at: data.sent_at
        ||
        null
            ,
            
        is_faq_suggested: data.is_faq_suggested
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await chat_messages.setSession( data.session || null, {
            transaction,
        });
        
        await chat_messages.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return chat_messages;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const chat_messagesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                sender_type: item.sender_type
            ||
            null
            ,
            
                sender_display_name: item.sender_display_name
            ||
            null
            ,
            
                message_text: item.message_text
            ||
            null
            ,
            
                sent_at: item.sent_at
            ||
            null
            ,
            
                is_faq_suggested: item.is_faq_suggested
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const chat_messages = await db.chat_messages.bulkCreate(chat_messagesData, { transaction });

        // For each item created, replace relation files
        

        return chat_messages;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const chat_messages = await db.chat_messages.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.sender_type !== undefined) updatePayload.sender_type = data.sender_type;
        
        
        if (data.sender_display_name !== undefined) updatePayload.sender_display_name = data.sender_display_name;
        
        
        if (data.message_text !== undefined) updatePayload.message_text = data.message_text;
        
        
        if (data.sent_at !== undefined) updatePayload.sent_at = data.sent_at;
        
        
        if (data.is_faq_suggested !== undefined) updatePayload.is_faq_suggested = data.is_faq_suggested;
        
        
        updatePayload.updatedById = currentUser.id;

        await chat_messages.update(updatePayload, {transaction});

        
        
        if (data.session !== undefined) {
            await chat_messages.setSession(
              
              data.session,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await chat_messages.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return chat_messages;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const chat_messages = await db.chat_messages.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of chat_messages) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of chat_messages) {
                await record.destroy({transaction});
            }
        });


        return chat_messages;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const chat_messages = await db.chat_messages.findByPk(id, options);

        await chat_messages.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await chat_messages.destroy({
            transaction
        });

        return chat_messages;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const chat_messages = await db.chat_messages.findOne(
            { where },
            { transaction },
        );

        if (!chat_messages) {
            return chat_messages;
        }

        const output = chat_messages.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.session = await chat_messages.getSession({
            transaction
        });
        
        
        output.organizations = await chat_messages.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.chat_sessions,
        as: 'session',
        
        where: filter.session ? {
          [Op.or]: [
            { id: { [Op.in]: filter.session.split('|').map(term => Utils.uuid(term)) } },
            {
              session_key: {
                [Op.or]: filter.session.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.sender_display_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'chat_messages',
                        'sender_display_name',
                        filter.sender_display_name,
                    ),
                };
            }
            
            if (filter.message_text) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'chat_messages',
                        'message_text',
                        filter.message_text,
                    ),
                };
            }
            

            
            

            
            if (filter.sent_atRange) {
                const [start, end] = filter.sent_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    sent_at: {
                    ...where.sent_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    sent_at: {
                    ...where.sent_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.sender_type) {
                where = {
                    ...where,
                sender_type: filter.sender_type,
            };
            }
            
            if (filter.is_faq_suggested) {
                where = {
                    ...where,
                is_faq_suggested: filter.is_faq_suggested,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.chat_messages.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'chat_messages',
                        'sender_display_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.chat_messages.findAll({
            attributes: [ 'id', 'sender_display_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['sender_display_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.sender_display_name,
        }));
    }

    
};

